package factory.tools.gradle.go

import factory.tools.gradle.go.tasks.AbstractGoExec
import factory.tools.gradle.go.tasks.CacheableDownload
import factory.tools.gradle.go.tasks.Extract
import factory.tools.gradle.go.tasks.GoBuild
import factory.tools.gradle.go.tasks.GoExec
import org.gradle.api.*

internal val versionRegex = Regex("""^1\.[0-9]+(\.[0-9]+)?$""")

fun createGoDsl(project: Project) {
    val ext = project.extensions.create(
        GO_EXTENSION_NAME,
        GoExtension::class.java,
        project
    )

    val downloadInfo by lazy { GoDownloadInfo.build(ext.version) }

    val buildDir by lazy {
        if (ext.installInRoot) {
            project.rootProject.layout.buildDirectory
        } else {
            project.layout.buildDirectory
        }
    }

    project.afterEvaluate {
        validateUserData(
            versionRegex.matches(ext.version),
            "The go version \"${ext.version}\" is not valid (regex: \"$versionRegex\")"
        )
    }

    project.tasks.register("installSdk", Extract::class.java) { task ->
        task.apply {
            dependsOn("downloadSdk")
            group = "go"

            archive = buildDir.file("download/${downloadInfo.fileName}").get().asFile
            extension = downloadInfo.ext
            dest = buildDir.file("go").get().asFile

            stripPrefix("go/")

            doLast {
                project.exec {
                    it.commandLine(buildDir.file("go/bin/go").get().asFile, "version")
                }
            }
        }
    }

    project.tasks.register("downloadSdk", CacheableDownload::class.java) {
        it.apply {
            group = "go"

            doFirst {
                buildDir.file("download").get().asFile.mkdirs()
            }

            src(downloadInfo.url)
            dest(buildDir.file("download/${downloadInfo.fileName}"))
            overwrite(false)
            tempAndMove(true)
        }
    }

    project.tasks.register("generateGopathWrapper") {
        it.apply {
            group = "help"

            doLast {
                val relBuild = buildDir.get().asFile.relativeTo(project.layout.projectDirectory.asFile)
                // language=bash
                val script = """
                    #!/bin/bash -i
                    # This file is automatically generated by :generateGopathWrapper
                    basepath="${'$'}(cd "${'$'}(dirname "${'$'}1")"; pwd)"
                    
                    export GOROOT="${'$'}{basepath}/${relBuild}/go"
                    export GOPATH="${'$'}{basepath}/${relBuild}/gopath"
                    export PATH="${'$'}{GOROOT}/bin:${'$'}{GOPATH}/bin:${'$'}{PATH}"
                    export PS1="(gopath ${project.path}) ${'$'}{PS1:-}"
                    
                    exec bash --norc
                """.trimIndent()
                val wrapperFile = project.layout.projectDirectory.file("gow").asFile
                wrapperFile.writeText(script)
                wrapperFile.setExecutable(true)
            }
        }
    }

    if (ext.defaultBuild) {
        project.tasks.register("assemble", GoBuild::class.java)
    }

    // Task to dsl
    val extraProperties = project.extensions.extraProperties
    extraProperties[GoExec::class.java.simpleName] = GoExec::class.java
    extraProperties[GoBuild::class.java.simpleName] = GoBuild::class.java
    extraProperties[AbstractGoExec::class.java.simpleName] = AbstractGoExec::class.java
    extraProperties[GoTarget::class.java.simpleName] = GoTarget::class.java
}
